﻿#coding=UTF-8
import sys
from PyQt4 import QtGui, QtCore
from NDSRS12 import Ui_NDSRS as Dlg
import os
import shutil
import codecs
import gzip
import time
import ConfigParser

os.environ["LANG"]="en_US.UTF-8"


class MeinDialog(QtGui.QDialog, Dlg):
    def __init__(self):
        QtGui.QDialog.__init__(self)
        self.setupUi(self)
        self.setWindowTitle('NDSRS & FullRecall Import    by nannys_hedgehog')
        self.connect(self.inputPathInfile,QtCore.SIGNAL("clicked()"), self.onInputPathInfile)
        self.connect (self.Delimiter,QtCore.SIGNAL ("currentIndexChanged(int)"),self.ShowInput)
        self.connect(self.OpenpathWyabdc,QtCore.SIGNAL("clicked()"), self.onOpenpathWyabdc)
        self.connect(self.openSox,QtCore.SIGNAL("clicked()"), self.onOpenpathSox)
        self.connect(self.openSoundNDS,QtCore.SIGNAL("clicked()"), self.onOpenSoundNDS)
        self.connect(self.CustomFont,QtCore.SIGNAL("currentFontChanged(QFont)"), self.updateUi)
        self.connect(self.FontUp,QtCore.SIGNAL("valueChanged(int)"), self.updateUi)
        self.connect(self.FontDown,QtCore.SIGNAL("valueChanged(int)"), self.updateUi)
        self.connect(self.buttonNDSRSConv,QtCore.SIGNAL("clicked()"), self.onNDSRSConv)
        self.connect(self.buttonFullRecallConv,QtCore.SIGNAL("clicked()"), self.onFullRecallConv)
        self.connect(self.buttonCancel,QtCore.SIGNAL("clicked()"), self.onAbbrechen)
        if os.path.isfile(os.getcwd()+'\\'+'NDSRS.cfg'):self.ConfigurationRead()


    def onInputPathInfile(self):
        Delimiter = self.Delimiter.currentText()
        if Delimiter == 'tab': Delimiter = '\t'
        Infile = unicode(QtGui.QFileDialog.getOpenFileName(self, "Choose a CSV-, Text- or Pauker file to import","", "CSV (*.csv)\nText (*.txt)\nPauker (*.pau.gz)")).encode('utf-8')
        from os.path import isfile
        if isfile(Infile):
            self.pathInfile.setText(Infile)
            InfileTyp = Infile.split('.')[-1]
            pathInfile = self.pathInfile.text()
            path = unicode(pathInfile).encode("utf-8")
            InfileTyp = path.split('.')[-1]
            if InfileTyp == "gz": #                print "Pauker Import"
                d = gzip.open(path).read()
                l = []
                p = 0
                while True:
                    p = GetPoint(d, p+1, '<')
                    if p == -1:
                        break
                    if d[p:p+6] == '<Card>':
                        qa = []
                        while True:
                            p = GetPoint(d, p+1, '<')
                            if d[p:p+6] == '<Text>':
                                ep = GetPoint(d, p+1, '<')
                                qa.append(d[p+6:ep])
                                p = ep
                                if len(qa) == 2:
                                    l.append(qa)
                                    break

                end = []
                frage = l[0][0]
                antwort = l[0][1]
                self.Question.setPlainText(unicode(frage, 'UTF-8'))
                self.Answer.setPlainText(unicode(antwort, 'UTF-8'))
##CSV and TXT Files
            else:
                d = codecs.open(path,'r','utf-8').read().split('\n')
                i = d[0]
                i = i.replace("&", "&amp;")
                l = i.replace('\r','').split(Delimiter)
                i = l[1]
                frage = l[0]
                antwort = i
                self.Question.setPlainText(frage)
                self.Answer.setPlainText(antwort)

    def ShowInput(self):

        Delimiter = self.Delimiter.currentText()
        if Delimiter == 'tab': Delimiter = '\t'
        Infile = self.pathInfile.text()
        from os.path import isfile
        if isfile(Infile):
            InfileTyp = Infile.split('.')[-1]
            pathInfile = self.pathInfile.text()
            path = unicode(pathInfile).encode("utf-8")
            InfileTyp = path.split('.')[-1]
            if InfileTyp == "gz":
                d = gzip.open(path).read()
                l = []
                p = 0
                while True:
                    p = GetPoint(d, p+1, '<')
                    if p == -1:
                        break
                    if d[p:p+6] == '<Card>':
                        qa = []
                        while True:
                            p = GetPoint(d, p+1, '<')
                            if d[p:p+6] == '<Text>':
                                ep = GetPoint(d, p+1, '<')
                                qa.append(d[p+6:ep])
                                p = ep
                                if len(qa) == 2:
                                    l.append(qa)
                                    break

                end = []
                frage = l[0][0]
                antwort = l[0][1]
                self.Question.setPlainText(unicode(frage, 'UTF-8'))
                self.Answer.setPlainText(unicode(antwort, 'UTF-8'))
    ##CSV and TXT Files
            else:
                d = codecs.open(path,'r','utf-8').read().split('\n')
                i = d[0]
                i = i.replace("&", "&amp;")
                l = i.replace('\r','').split(Delimiter)
                i = l[1]
                frage = l[0]
                antwort = i
                self.Question.setPlainText(frage)
                self.Answer.setPlainText(antwort)


    def onOpenpathWyabdc(self):
        Openpath = QtGui.QFileDialog.getOpenFileName(self, "Choose a .ogg or .wav file from pronounciation path","", "Shtooka (*.ogg)\nWyabdcRealpeopleTTs (*.wav)")
        suffix = Openpath.split('.')[-1]
        global encoding
        if suffix == "wav":
            encoding = "wav"
            raus = Openpath.split('/')[-1] #getfilename
            Openpath = Openpath.replace('/'+raus,"")#remove filename from string
            raus = Openpath.split('/')[-1] #get last path part
            Openpath = Openpath.replace('/'+raus,"")#remove filename from string
            self.pathWyabdc.setText(Openpath)

        else: #suffix must be "ogg"
            encoding = "ogg"
            raus = Openpath.split('/')[-1] #getfilename
            Openpath = Openpath.replace('/'+raus,"")#remove filename from string
            unicode (self.pathWyabdc.setText(Openpath))

    def onOpenpathSox(self):
        Openpath_Sox = QtGui.QFileDialog.getOpenFileName(self, "Point to working Sox.exe","", "(Sox.exe)")
        self.pathtoSox.setText(Openpath_Sox)

    def onOpenSoundNDS(self):
		OpenSoundNDS = QtGui.QFileDialog.getExistingDirectory()
 		self.pathSoundNDS.setText(OpenSoundNDS)

    def updateUi(self):
        font = self.CustomFont.currentFont()
        font.setPointSize(self.FontUp.value()/float(4)*3)
        self.Question.setFont(font)
        font.setPointSize(self.FontDown.value()/float(4)*3)
        self.Answer.setFont(font)

    def onNDSRSConv(self):
        Delimiter = self.Delimiter.currentText()
        if Delimiter == 'tab': Delimiter = '\t'
        global encoding
        pathInfile = self.pathInfile.text()
        pathSoundNDS = self.pathSoundNDS.text()
        pathWyabdc =self.pathWyabdc.text()
        pathSox = str(self.pathtoSox.text())

        d = {}

        path = unicode(pathInfile).encode("utf-8")
        DICTPREFIX = unicode(pathWyabdc).encode("utf-8")
        CARDPREFIX = unicode(pathSoundNDS).encode("utf-8")
        FontUp = self.FontUp.value()
        FontDown = self.FontDown.value()
        InfileTyp = path.split('.')[-1]
        if InfileTyp == "gz":
            d = gzip.open(path).read()
            l = []
            p = 0
            while True:
                p = GetPoint(d, p+1, '<')
                if p == -1:
                    break
                if d[p:p+6] == '<Card>':
                    qa = []
                    while True:
                        p = GetPoint(d, p+1, '<')
                        if d[p:p+6] == '<Text>':
                            ep = GetPoint(d, p+1, '<')
                            qa.append(d[p+6:ep])
                            p = ep
                            if len(qa) == 2:
                                l.append(qa)
                                break

            end = []
            end.append('<deck>')
            for i in l:
                end.append('  <card>')
                end.append('    <question size=\"%s\">%s</question>' % (FontUp, i[0]))
                end.append('    <answer size=\"%s\">%s</answer>' % (FontDown, i[1]))
                end.append('  </card>')

            end.append('</deck>\n')
            name = path.split('.')[0]
            name = name.split('/')[-1]
            if not os.path.exists(CARDPREFIX + 'ndsrs'):os.mkdir(CARDPREFIX + 'ndsrs')
            of = CARDPREFIX + 'ndsrs/' + name + '.srs'
            f = file(of, "w")
            f.write('\n'.join(end))
            f.close()
            ret = QtGui.QMessageBox.question(self, 'NDSRS Import',"Conversion ready\nFile saved at:\n\n%s\n\nDo you want to quit NDSRS-Import now?"%of, QtGui.QMessageBox.Yes, QtGui.QMessageBox.No)
            if ret == QtGui.QMessageBox.Yes:
                self.Configuration()
                self.close()


        else:
            d = open(path).read().split('\n')
            name = path.split('.')[0]
            name = name.split('/')[-1]
            if not os.path.exists(CARDPREFIX + 'NDSRS'):os.mkdir(CARDPREFIX + 'NDSRS')
            of = CARDPREFIX + 'ndsrs/' + name + '.srs'
            o = file(of, "w")
            c = 0
            o.write("<deck>\n")
            for i in d:
                if i.strip() == '':
                    continue
                i = i.replace("&", "&amp;")
                l = i.replace('\r','').split(Delimiter)
                o.write("  <card>\n")
                o.write("    <question size=\"%s\">" %FontUp + l[0] + "</question>\n")
                for i in l[1:]:
                    if i !='':#only if answerfields are not empty
                        if self.checkPronounciation.checkState():                # copy stuff over!
                            u = ""
                            if encoding == "wav": u = i[0]+"/"
                            s = "%s/%s%s.%s" % (DICTPREFIX, u,  i, encoding)
                            t = s.replace('/', '\\')
                            if encoding != "wav": t = t.decode("UTF-8")
                            cfile = name + "-" + str(c)
                            if not os.path.exists(CARDPREFIX + 'NDSRS/DATA'):os.mkdir(CARDPREFIX + 'NDSRS/DATA')
                            if not os.path.exists(CARDPREFIX + 'NDSRS/DATA/SND'):os.mkdir(CARDPREFIX + 'NDSRS/DATA/SND')
                            d = CARDPREFIX + "ndsrs/data/snd/%s.%s" % (cfile, encoding)
                            e = d.replace('/', '\\')
                            f = e.split('.')[0] + '.wav'
                            if os.path.isfile(t): #hier wird schon ausgesiebt
                                try:
                                    shutil.copyfile(t,e)
                                    o.write('    <answer size=\"%s\" sound="data/snd/%s.wav">%s</answer>\n' % (FontDown, cfile, i))
                                    if encoding == "ogg" and os.path.isfile(pathSox):
                                        cmd = "\"%s\" -r 22050 -2 -c 1 -q \"%s\" contrast 75"  % (e, f) #test sox
                                        ub = os.popen(pathSox + ' ' + cmd) #vorher os.system jetzt wird output nach ub geleitet
                                        #time.sleep(6)
                                    c=c+1

                                except IOError:
                                    QtGui.QMessageBox.warning(self, 'NDSRS Import Error',"Couldn't copy sound file to path:\n\n %sndsrs/data/snd\n\nPath probably doesn't exist!\nConversion stopped." % (CARDPREFIX))
                                    o.write('    <answer size=\"%s\">%s</answer>\n' % (FontDown, i))
                                    raise()
                            else:
                                n = i.split()
                                size = len(n)
                                Soundfile =""
                                for ni in n[0:]:
                                    if ni !='':
                                        ni=ni.replace(',','')
                                        ni=ni.replace(';','')
                                        ni=ni.replace('.','')
                                        ni=ni.replace('!','')
                                        ni=ni.replace('?','')
                                        ni=ni.replace('-','')
                                        ni=ni.replace(':','')
                                        u = ""
                                        if encoding == "wav": u = ni[0]+"/"
                                        Soundfileakut = DICTPREFIX+'/'+u+ni+'.'+encoding
                                        Soundfileakut = Soundfileakut.replace('/', '\\')
                                        if encoding != "wav": Soundfileakut = Soundfileakut.decode("UTF-8")
                                        if os.path.isfile(Soundfileakut):
                                            Soundfile = Soundfile + ' ' + Soundfileakut
                                if Soundfile != "":
                                    Soundfile=unicode(Soundfile).encode("latin-1")#Das war die magische Formel um die Dateien zu lesen
                                    cmd = " --combin concatenate %s -r 22050 -2 -c 1 -q \"%s\" contrast 75"  % (Soundfile, f) #test sox
                                    ub = os.popen(pathSox + cmd)#vorher os.system jetzt wird output nach ub geleitet
                                    o.write('    <answer size=\"%s\" sound="data/snd/%s.wav">%s</answer>\n' % (FontDown, cfile, i))
                                    c=c+1
                                else:
                                    o.write('    <answer size=\"%s\">%s</answer>\n' % (FontDown, i))

                        else:
                            o.write('    <answer size=\"%s\">%s</answer>\n' % (FontDown, i))
                o.write("  </card>\n")

            o.write("</deck>\n")

            o.close()
            if encoding == "ogg":
                if not os.path.isfile(pathSox):
                    QtGui.QMessageBox.warning(self, 'NDSRS Recall Import Error',"Couldn't convert sound file from ogg to wav\n\n %s doesn't exist!\nConversion stopped.\n\nYou have to convert the ogg-files in %s \nmanually into wav-format." % (pathSox, CARDPREFIX + 'ndsrs/data/snd/'))
                else:
                    time.sleep(1) #sonst wird das letzte ogg-file nicht konvertiert
                    directory = os.listdir(CARDPREFIX + 'ndsrs/data/snd/')
                    for filename in directory:
                        if filename[-3:] == 'ogg':
                            os.remove(CARDPREFIX + 'ndsrs/data/snd/' + filename)

            ret = QtGui.QMessageBox.question(self, 'NDSRS Import',"Conversion ready\nFile saved as:\n\n%s\n\nDo you want to quit NDSRS-Import now?"%of, QtGui.QMessageBox.Yes, QtGui.QMessageBox.No)
            if ret == QtGui.QMessageBox.Yes:
                self.Configuration()
                self.close()

    def onFullRecallConv(self):
        Delimiter = self.Delimiter.currentText()
        if Delimiter == 'tab': Delimiter = '\t'
        global encoding
        pathInfile = self.pathInfile.text()
        pathSoundNDS = self.pathSoundNDS.text()
        pathWyabdc =self.pathWyabdc.text()
        pathSox = str(self.pathtoSox.text())

        d = {}

        path = unicode(pathInfile).encode("utf-8")
        DICTPREFIX = unicode(pathWyabdc).encode("utf-8")
        CARDPREFIX = unicode(pathSoundNDS).encode("utf-8")
        FontUp = self.FontUp.value()
        FontDown = self.FontDown.value()
        InfileTyp = path.split('.')[-1]
        if InfileTyp == "gz":
            d = gzip.open(path).read()
            l = []
            p = 0
            while True:
                p = GetPoint(d, p+1, '<')
                if p == -1:
                    break
                if d[p:p+6] == '<Card>':
                    qa = []
                    while True:
                        p = GetPoint(d, p+1, '<')
                        if d[p:p+6] == '<Text>':
                            ep = GetPoint(d, p+1, '<')
                            qa.append(d[p+6:ep])
                            p = ep
                            if len(qa) == 2:
                                l.append(qa)
                                break

            end = []
            name = path.split('.')[0]
            name = name.split('/')[-1]
            end.append('<category name=\"%s">' %(name))
            for i in l:
                end.append('<q>%s</q>' % (i[0]))
                end.append('<a>%s</a>' % (i[1]))

            end.append('</category>\n')
            name = path.split('.')[0]
            name = name.split('/')[-1]
            if not os.path.exists(CARDPREFIX + 'fullrecalldb/' + name):os.mkdir(CARDPREFIX + 'fullrecalldb/' + name)
            of = CARDPREFIX + 'fullrecalldb/' + name + '/queue.txt'
            f = file(of, "w")
            f.write('\n'.join(end))
            f.close()
            ret = QtGui.QMessageBox.question(self, 'FullRecall Import',"Conversion ready\nFile saved at:\n\n%s\n\nDo you want to quit FullRecall-Import now?"%of, QtGui.QMessageBox.Yes, QtGui.QMessageBox.No)
            if ret == QtGui.QMessageBox.Yes:
                self.Configuration()
                self.close()


        else:
            d = open(path).read().split('\n')
            name = path.split('.')[0]
            name = name.split('/')[-1]
            if not os.path.exists(CARDPREFIX + 'fullrecalldb'):os.mkdir(CARDPREFIX + 'fullrecalldb')
            if not os.path.exists(CARDPREFIX + 'fullrecalldb/' + name):os.mkdir(CARDPREFIX + 'fullrecalldb/' + name)
            of = CARDPREFIX + 'fullrecalldb/' + name + '/queue.txt'
            o = file(of, "w")
            c = 0
            o.write("<category name=\"%s\">\n"%(name))
            for i in d:
                if i.strip() == '':
                    continue
                i = i.replace("&", "&amp;")
                l = i.replace('\r','').split(Delimiter,1)#wenn die 1 fehlt wird in verschiedene Antwortkarten aufgeteilt, wenn da nur eine Antwortkarte
                o.write("<q>" +l[0] + "</q>\n")
                for i in l[1:]:
                    if i !='':#only if answerfields are not empty
                        i = i.replace(Delimiter, "; ")
                        if self.checkPronounciation.checkState():                # copy stuff over!
                            u = ""
                            if encoding == "wav": u = i[0]+"/"
                            s = "%s/%s%s.%s" % (DICTPREFIX, u,  i, encoding)
                            t = s.replace('/', '\\')
                            if encoding != "wav": t = t.decode("UTF-8")
                            cfile = name + "-" + str(c)
                            #d = CARDPREFIX + "fullrecalldb/\"%s\"/%s.%s" % (name, cfile, encoding)
                            d = CARDPREFIX + 'fullrecalldb/' + name + "/" + cfile + "." + encoding
                            e = d.replace('/', '\\')
                            f = e.split('.')[0] + '.wav'
                            if os.path.isfile(t): #hier wird schon ausgesiebt
                                try:
                                    shutil.copyfile(t,e)
                                    o.write('<a>%s<snd>%s.wav</snd></a>\n' % (i, cfile))
                                    if encoding == "ogg" and os.path.isfile(pathSox):
                                        cmd = "\"%s\" -r 22050 -2 -c 1 -q \"%s\" contrast 75"  % (e, f) #test sox
                                        ub = os.popen(pathSox + ' ' + cmd) #vorher os.system jetzt wird output nach ub geleitet
                                    c=c+1

                                except IOError:
                                    QtGui.QMessageBox.warning(self, 'FullRecall Import Error',"Couldn't copy sound file to path:\n\n %sfullrecalldb\n\nPath probably doesn't exist!\nConversion stopped." % (CARDPREFIX))
                                    o.write('<a>%s</a>\n' % (i))
                                    raise()
                            else:
                                n = i.split()
                                size = len(n)
                                Soundfile =""
                                for ni in n[0:]:
                                    if ni !='':
                                        ni=ni.replace(',','')
                                        ni=ni.replace(';','')
                                        ni=ni.replace('.','')
                                        ni=ni.replace('!','')
                                        ni=ni.replace('?','')
                                        ni=ni.replace('-','')
                                        ni=ni.replace(':','')
                                        u = ""
                                        if encoding == "wav": u = ni[0]+"/"
                                        Soundfileakut = DICTPREFIX+'/'+u+ni+'.'+encoding
                                        Soundfileakut = Soundfileakut.replace('/', '\\')
                                        if encoding != "wav": Soundfileakut = Soundfileakut.decode("UTF-8")
                                        if os.path.isfile(Soundfileakut):
                                            Soundfile = Soundfile + ' ' + Soundfileakut
                                if Soundfile != "":
                                    Soundfile=unicode(Soundfile).encode("latin-1")#Das war die magische Formel um die Dateien zu lesen
                                    cmd = " --combin concatenate %s -r 22050 -2 -c 1 -q \"%s\" contrast 75"  % (Soundfile, f) #test sox
                                    ub = os.popen(pathSox + cmd)#vorher os.system jetzt wird output nach ub geleitet
                                    o.write('<a>%s<snd>%s.wav</snd></a>\n' % (i, cfile))
                                    c=c+1
                                else:
                                    o.write('<a>%s</a>\n' % (i))


            o.write("</category>\n")
            o.close()
            if encoding == "ogg":
                if not os.path.isfile(pathSox):
                    QtGui.QMessageBox.warning(self, 'Full Recall Import Error',"Couldn't convert sound file from ogg to wav\n\n %s doesn't exist!\nConversion stopped.\n\nYou have to convert the ogg-files in %s \nmanually into wav-format." % (pathSox, CARDPREFIX + 'fullrecalldb/'))
                else:
                    time.sleep(1) #sonst wird das letzte ogg-file nicht konvertiert
                    directory = os.listdir(CARDPREFIX + 'fullrecalldb/' + name)
                    for filename in directory:
                        if filename[-3:] == 'ogg':
                            os.remove(CARDPREFIX + 'fullrecalldb/' + name + '/'  + filename)

            ret = QtGui.QMessageBox.question(self, 'FullRecall Import',"Conversion ready\nFile saved as:\n\n%s\n\nDo you want to quit FullRecall-Import now?"%of, QtGui.QMessageBox.Yes, QtGui.QMessageBox.No)
            if ret == QtGui.QMessageBox.Yes:
                self.Configuration()
                self.close()

    def onAbbrechen(self):
        self.Configuration()
        self.close()

    def Configuration(self): #write
        Configpath=os.getcwd()+'\\'+'NDSRS.cfg'
        Configpath = Configpath.replace('\\','/' )
        config = ConfigParser.RawConfigParser()
        config.add_section('In/Output')
        config.add_section('Pronounciation')
        config.set('Pronounciation', 'pathWyabdc', self.pathWyabdc.text())
        config.set('Pronounciation', 'pathSox' , self.pathtoSox.text())
        config.set('Pronounciation', 'Encoding' , encoding)
        config.set('Pronounciation', 'Pronounciation' , self.checkPronounciation.checkState())
        config.set('In/Output', 'pathOutfile', self.pathSoundNDS.text())
        config.set('In/Output', 'pathInfile', self.pathInfile.text())

        configfile=(Configpath)
        configf=open(configfile, 'wb')
        config.write(configf)

    def ConfigurationRead(self):
        Configpath=os.getcwd()+'\\'+'NDSRS.cfg'
        Configpath = Configpath.replace('\\','/' )
        config = ConfigParser.ConfigParser()
        config.read(Configpath)
        self.pathWyabdc.setText(config.get('Pronounciation', 'pathWyabdc'))
        self.pathtoSox.setText(config.get('Pronounciation', 'pathSox'))
        global encoding
        encoding=config.get('Pronounciation', 'Encoding')
        if config.get('Pronounciation', 'Pronounciation')== '2':self.checkPronounciation.setChecked(2)
        self.pathSoundNDS.setText(config.get('In/Output', 'pathOutfile'))
        self.pathInfile.setText(config.get('In/Output', 'pathInfile'))


def GetPoint(s, i, c):
    try:
        while True:
            if s[i] == c:
                return i
            i += 1
    except:
        return -1

def ShowInput():


    Delimiter = self.Delimiter.currentText()
    if Delimiter == 'tab': Delimiter = '\t'
    Infile = self.pathInfile.currentText()
    from os.path import isfile
    if isfile(Infile):
        InfileTyp = Infile.split('.')[-1]
        pathInfile = self.pathInfile.text()
        path = unicode(pathInfile).encode("utf-8")
        FontUp = self.FontUp.value()/float(4)*3
        FontDown = self.FontDown.value()/float(4)*3
        InfileTyp = path.split('.')[-1]
        if InfileTyp == "gz":
            d = gzip.open(path).read()
            l = []
            p = 0
            while True:
                p = GetPoint(d, p+1, '<')
                if p == -1:
                    break
                if d[p:p+6] == '<Card>':
                    qa = []
                    while True:
                        p = GetPoint(d, p+1, '<')
                        if d[p:p+6] == '<Text>':
                            ep = GetPoint(d, p+1, '<')
                            qa.append(d[p+6:ep])
                            p = ep
                            if len(qa) == 2:
                                l.append(qa)
                                break

            end = []
            frage = l[0][0]
            antwort = l[0][1]
            self.Question.setPlainText(unicode(frage, 'UTF-8'))
            self.Answer.setPlainText(unicode(antwort, 'UTF-8'))
##CSV and TXT Files
        else:
            d = codecs.open(path,'r','utf-8').read().split('\n')
            i = d[0]
            i = i.replace("&", "&amp;")
            l = i.replace('\r','').split(Delimiter)
            i = l[1]
            frage = l[0]
            antwort = i
            self.Question.setPlainText(frage)
            self.Answer.setPlainText(antwort)


global encoding
app = QtGui.QApplication(sys.argv)
dialog = MeinDialog()
dialog.show()
sys.exit(app.exec_())